Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Local_RLock Class Reference

Class that acquires, renews, and releases a readers lock that is local to the process. More...

`#include <Local_Tokens.h>`

Inheritance diagram for ACE_Local_RLock:

[legend]
Collaboration diagram for ACE_Local_RLock:

[legend]
List of all members.

## Public Methods
| ACE_Local_RLock (const ACE_TCHAR *token_name=0, int ignore_deadlock=0, int debug=0)
| Constructor. More...
| ~ACE_Local_RLock (void)
| Destructor. More...
void | dump (void) const
| Dump the state of the class. More...
virtual int | type (void) const
| Returns ACE_RW_Token::RLOCK. More...
virtual ACE_Token_Proxy * | clone (void) const
| Return deep copy. More...
## Protected Methods
virtual ACE_Tokens * | create_token (const ACE_TCHAR *name)
| Return a new ACE_Local_Mutex. More...

## Detailed Description

Class that acquires, renews, and releases a readers lock that is local to the process.

This class implements the reader interface to canonical readers/writer locks. Multiple readers can hold the lock simultaneously when no writers have the lock. Alternatively, when a writer holds the lock, no other participants (readers or writers) may hold the lock. This class is a more general-purpose synchronization mechanism than SunOS 5.x RLocks. For example, it implements "recursive RLock" semantics, where a thread that owns the token can reacquire it without deadlocking. In addition, threads that are blocked awaiting the token are serviced in strict FIFO order as other threads release the token (SunOS 5.x RLockes don't strictly enforce an acquisition order). The interfaces for acquire, tryacquire, renew, release, etc. are defined in ACE_Token_Proxy. The semantics for ACE_Local_RLock are that of a readers/writers lock. Acquire for this class implies a reader acquisition. That is, multiple clients may acquire a lock for read only.

## Constructor & Destructor Documentation

ACE_Local_RLock::ACE_Local_RLock | ( | const ACE_TCHAR * | token_name = 0,
|  | int | ignore_deadlock = 0,
|  | int | debug = 0
| ) |

  | Constructor. Parameters:
  token_name | Uniquely id's the token.
  ignore_deadlock | Will allow deadlock to occur (useful for testing).
  debug | Prints a bunch of messages.

ACE_Local_RLock::~ACE_Local_RLock | ( | void |  | ) |

| Destructor.

## Member Function Documentation

virtual ACE_Token_Proxy* ACE_Local_RLock::clone | ( | void |  | ) | const`[virtual]`

| Return deep copy. Reimplemented from ACE_Token_Proxy.

virtual ACE_Tokens* ACE_Local_RLock::create_token | ( | const ACE_TCHAR * | name | ) | `[protected, virtual]`

| Return a new ACE_Local_Mutex. Reimplemented from ACE_Token_Proxy.

void ACE_Local_RLock::dump | ( | void |  | ) | const

| Dump the state of the class. Reimplemented from ACE_Token_Proxy.

virtual int ACE_Local_RLock::type | ( | void |  | ) | const`[virtual]`

| Returns ACE_RW_Token::RLOCK. Reimplemented from ACE_Token_Proxy.

The documentation for this class was generated from the following file:

- Local_Tokens.h